//  trp.cc     test Reactive Planner
//  Paul Schmitt 8-23-94
//  Version 4.000

#include <Graphics_View.hh>
#include <Environment.hh>
#include <Mechanism.hh>
#include <unistd.h>
#include <Sensor.hh>
#include <MapVehicleOutline.hh>
#include <Histogram.hh>
#include <Planner.hh>

void main() {
//Set up View
   Graphics_View view_one;
   view_one.ReadView("plan.view");

//Set up Environment
   Environment environment;
   environment.ReadDescription(view_one, "FluctuatingAisle.env");

//Set up Mechanism VEHICLE
   Mechanism VEHICLE;
   VEHICLE.ReadDescription(view_one, "SWAMI.md");   

//Read configuration (optional initial conditions or use .md positions)
   VEHICLE.ReadConfiguration(view_one, "SWAMI.cfg");


//Begin motion

   Map EnvMap;
   EnvMap.ReadMap("Environ.mp");

   int mapNx = EnvMap.Get_Ncols();
   int mapNy = EnvMap.Get_Nrows();
   Map VehicleOutlineMap;

   VehicleOutlineMap.ReadMap("Environ.mp");
   Histogram Layout("Sensor Data Histogram", mapNx, mapNy, 2);


// Lay down a path ?
   ifstream inputfilet("Turd.txt", ios::in);
   int lay_a_turd, skip;
   inputfilet >> lay_a_turd >> skip;
   cout << "Lay_a_turd = " << lay_a_turd << endl;
   inputfilet.close();
   int count = skip;
   Iterator<Joint_Value> jvpositions;
   double xpos, ypos, theta;   


//   int Goal_Reached = 0;
   int step=0;
   Iterator <Joint_Value> tempJVIter;
   Iterator <Link> tempLinkIter;
   
//Find type of given vehicle Is vehicle a tricycle?
   tempLinkIter = VEHICLE.GetIterator();
   tempLinkIter.Head();
   Planner Path(tempLinkIter);

   ifstream List_of_Goal_Points("RPSDemo.gpt", ios::in);
   while(!List_of_Goal_Points.eof()){
      //Take goal point out of Parameters and make new function to read
      //new goal point and put in private parts.
      Path.ReadGoalPoint(List_of_Goal_Points);
      Path.ResetVariables();

      //Get initial picture of environment
      EnvMap.UpdateMap();
      EnvMap.UpdateMap();
      EnvMap.UpdateMap();

      while( Path.Get_CurrentViaPoint() != Path.Get_NumViaPoints() )
	    {
	       //Initialize PlanIter before loop
	       //Where is the mechanism??
	       tempLinkIter = VEHICLE.GetIterator();
	       tempLinkIter.Head();
//	       tempJVIter = tempLinkIter()->Positions();      
	       tempJVIter = tempLinkIter()->JVIterator();      
	       Path.Set_PlanIter(tempJVIter);
	       //EnvMap.Decay(2);
	       EnvMap.UpdateMap();
	       // MVO param length, width, p, theta
	       // p is the distance from rear(driving) axle to front
	       //for Knife this is half the length
//	       Layout.Draw( (EnvMap+VehicleOutlineMap).Get_Map() );
	
	       Path.MakeReactivePath( EnvMap, "RPSDemo.parm");
	       step = 0;
	       while(step < Path.Get_Index()+1){
		  //Get_Index is number of t' NOT ss's
		  //increment based upon desired velocity;  returns new t value
		  step = Path.ReactiveIncrementor(Path.Get_Increment(), step);
		  tempJVIter = Path.Get_PlanIter();
		  VEHICLE.SetPosition(tempJVIter);
	
		  //Turd stuff
		  jvpositions = tempLinkIter()->JVIterator();
		  jvpositions.Head();
		  jvpositions++;
		  xpos = jvpositions()->JointValue();
		  jvpositions++;
		  ypos = jvpositions()->JointValue();
		  jvpositions++;
		  theta = jvpositions()->JointValue();
		  if(!count) {
		     if(lay_a_turd) {
			Transform tid;
			Rotation id(theta, Rotation::Z);
			Vector3 origin(xpos + 228*cos(theta),
				       ypos+228*sin(theta), 0.01);
			//SWAMI ->228*cos(theta), 228*sin(theta)
			Transform transform(id, origin);
			Plane *pl =
			   new Plane(transform, tid, 25, 1219, 711, 0); 
			}
		     count = skip;
		     }
		  count--;
		  
		  //EnvMap.Decay(1);
		  EnvMap.UpdateMap();
		  VehicleOutlineMap.markVehicleOutline(1219, 711, 838, theta);
		  EnvMap.TranslateData(xpos,ypos);
		  // SWAMI -> 1219, 711, 838     228
		  // Mort -> 1633, 787, 1430
		  // Denning diameter is 700
		  Layout.Draw( (EnvMap+VehicleOutlineMap).Get_Map() );
		  view_one.Regenerate_Screen();
		  }
	       //Read next goal point
	       }  
      
      }
   
   //Close goal point file
   List_of_Goal_Points.close();   
   
   cout << " Path.Get_CurrentViaPoint() " << Path.Get_CurrentViaPoint()
	<< "  Path.Get_NumViaPoints()-1 " << (Path.Get_NumViaPoints()-1)
	<< "\n";
   sleep(3);
   cout << "End of Program\n";
}
